![logo](logo.png)

<div align="center">
<p align="center">
    <a href="#installation">Installation</a> •
    <a href="#configuration">Configuration</a> •
    <a href="#examples">Examples</a>
</p>
</div>

# Installation
### Arch based
If you have ArchLinux based system, such as Manjaro or Arch itself, then simply clone the repo and run:
```bash 
git clone https://gitlab.le-memese.com/s3rius/music_bg
cd music_bg
makepkg -fsi
```

### Oter linux systems
- Install `rust` and `feh`. 
- Add `~/.cargo/bin` in your path.
- Run `cargo install --path .;`

If you want to add music_bg as systemd unit run:
```bash
cp systemd/music_bg.service /usr/lib/systemd/user/
systemctl --user enable music_bg.service
```

run `music_bg --version` to verify your installation.

# Configuration

After installation run `'music_bg config'`. This command will generate default config in your `$HOME` folder.
After that you free to edit your configuration `~/.mbg.toml`;

### Cofiguration format.
You can read more about TOML format [here](https://github.com/toml-lang/toml).
Main variables are `blender`, `reset_command` and `processors`.

`blender` is an array that shows how layers need to be merged. 

`reset_command` - command that will be executed when music stops.

`processors` - array of filter instructions.

Each `processor` has several fields:
- effect - actual image filter
- layer - number of layer
- strength - effect strength.

## Available filters
#TODO!

###  None

### Crop

### Blur

### Border


# Examples

With this [config](/example_confiigs/example1.toml), you would get images like this:
![example1_result](/example_confiigs/example1_res.png)